chiark / gitweb /
test suite: Drop a couple of useless test log output lines.
[dgit.git] / tests / lib
1 #
2
3 exec 2>&1
4 set -x
5 set -o pipefail
6
7 . tests/lib-core
8 . tests/lib-restricts
9
10 t-report-failure () {
11         set +x
12         rc=$1
13         cat <<END >&2
14 TEST FAILED
15 cwd: $PWD
16 funcs: ${FUNCNAME[*]}
17 lines: ${BASH_LINENO[*]}
18 files: ${BASH_SOURCE[*]}
19 END
20         t-save-artifacts
21
22         exit 16
23 }
24
25 trap 'test $? = 0 || t-report-failure' EXIT
26
27 t-filter-out-git-hyphen-dir
28
29 t-set-intree
30
31 : ${DGIT_TEST_DEBUG=-D}
32 export DGIT_TEST_DEBUG
33
34 : ${DGIT_TEST_DISTRO+ ${distro=${DGIT_TEST_DISTRO}}}
35
36 export GIT_COMMITTER_DATE='1515000000 +0100'
37 export GIT_AUTHOR_DATE='1515000000 +0100'
38
39 root=`pwd`
40 troot=$root/tests
41 testname="${DGIT_TEST_TESTNAME-${0##*/}}"
42 export DGIT_TEST_TROOT=$troot
43
44 tmp=$ADTTMP
45 if [ x"$tmp" = x ]; then
46         export DGIT_TEST_BYHAND=1
47         mkdir -p tests/tmp
48         tmpbase=$troot/tmp
49         tmp=tests/tmp/$testname
50         rm -rf $tmp
51         mkdir $tmp
52 elif [ "x$DGIT_TEST_TMPBASE" != x ]; then
53         tmpbase="$DGIT_TEST_TMPBASE"
54 fi
55 cd $tmp
56
57 tmp=`pwd`
58
59 t-set-using-tmp
60
61 test -f $tmp/.save-env || \
62 env -0 >$tmp/.save-env
63
64 ln -f $troot/ssh ssh
65
66 export DEBCHANGE_VENDOR=dpkg
67
68 mkdir -p $tmp/incoming
69 cat <<END >$tmp/dput.cf
70 [test-dummy]
71 method                  = local
72 incoming                = $tmp/incoming
73 run_dinstall            = 0
74 END
75
76 : ${t_archive_method:=aq}
77 : ${tagpfx:=archive/test-dummy}
78 : ${suitespecs:=sid:unstable}
79
80 t-git-next-date () {
81         GIT_COMMITTER_DATE="$(( ${GIT_COMMITTER_DATE%% *} + 1 )) ${GIT_COMMITTER_DATE#* }"
82         GIT_AUTHOR_DATE="$GIT_COMMITTER_DATE"
83 }
84
85 t-expect-fail () {
86         local mpat="$1"; shift
87
88         set +o pipefail
89         LC_MESSAGES=C "$@" 2>&1 | tee $tmp/t.output
90         local ps="${PIPESTATUS[*]}"
91         set -o pipefail
92
93         case $ps in
94         "0 0")  fail "command unexpectedly succeeded (instead of: $mpat)" ;;
95         *" 0")  ;;
96         *)      fail "tee failed"  ;;
97         esac
98
99         t-grep-mpat "$mpat" $tmp/t.output
100 }
101
102 t-grep-mpat () {
103         local mpat="$1"
104         local file="$2"
105
106         local grepper=fgrep
107         case "$mpat" in
108         [A-Z]:*)
109                 case "$mpat" in
110                 E:*)    grepper=egrep   ;;
111                 F:*)    grepper=fgrep   ;;
112                 *)      fail "bad mpat prefix in $mpat";;
113                 esac
114                 mpat=${mpat#[A-Z]:}
115                 ;;
116         esac
117
118         $grepper -e "$mpat" "$file" ||
119                 fail "message not found"
120 }
121
122 t-expect-push-fail () {
123         local mpat="$1"; shift
124
125         local triedpush; triedpush=`git rev-parse HEAD`
126
127         t-reporefs pre-push
128         t-expect-fail "$mpat"  "$@"
129         t-reporefs post-push
130         diff $tmp/show-refs.{pre,post}-push
131
132         t-git-objects-not-present '' $triedpush
133
134         eval "$t_expect_push_fail_hook"
135 }
136
137 t-git-objects-not-present () {
138         # t-git-objects-not-present GITDIR|'' OBJID [...]
139         # specifying '' means the repo for package $p
140         local gitdir="${1-$dgitrepo}"
141         local obj
142         if ! [ -e "$gitdir" ]; then return; fi
143         for obj in "$@"; do
144                 GIT_DIR=$gitdir \
145                 t-expect-fail 'unable to find' \
146                 git cat-file -t $obj
147         done
148 }
149
150 t-reporefs () {
151         local whichoutput=$1; shift
152         local whichrepo=${1-$dgitrepo}
153         local outputfile="$tmp/show-refs.$whichoutput"
154         (set -e
155          exec >"$outputfile"
156          if test -d $whichrepo; then
157                 cd $whichrepo
158                 git show-ref |t-sort
159         fi)
160 }
161
162 t-untar () {
163         local tarfile=$1.tar
164         local edittree=$1.edit
165         if test -d "$edittree"; then
166                 cp -a "$edittree"/* .
167         else
168                 tar xf "$tarfile"
169         fi
170 }
171
172 t-worktree () {
173         rm -rf $p
174         t-untar $troot/worktrees/${p}_$1
175 }
176
177 t-select-package () {
178         p=$1
179         dgitrepo=$tmp/git/$p.git
180 }
181
182 t-git () {
183         t-select-package $1
184         v=$2
185         mkdir -p $tmp/git
186         local gs=$troot/git-srcs/${p}_$v.git
187         (set -e; cd $tmp/git; t-untar $gs)
188 }
189
190 t-git-none () {
191         mkdir -p $tmp/git
192         (set -e; cd $tmp/git; tar xf $troot/git-template.tar)
193 }
194
195 t-salsa-add-remote () {
196         local d=$tmp/salsa/$p
197         mkdir -p $d
198         (set -e; cd $d; git init --bare)
199         git remote add ${1-origin} $d
200 }
201
202 t-git-merge-base () {
203         git merge-base $1 $2 || test $? = 1
204 }
205
206 t-has-ancestor () {
207         # t-has-ancestor ANCESTOR
208         # (CHILD is implicit, HEAD)
209         local now;      now=`git rev-parse HEAD`
210         local ancestor; ancestor=`git rev-parse $1^{}`
211         local mbase;    mbase=`t-git-merge-base $ancestor $now`
212         if [ x$mbase != x$ancestor ]; then
213                 fail "not ff $ancestor..$now, $mbase != $ancestor"
214         fi
215 }
216
217 t-has-parent-or-is () {
218         # t-has-parent-or-is CHILD PARENT
219         local child=$1
220         local parent=$2
221         local parents
222         parents=$(git show --pretty=format:' %P %H ' "$child")
223         parent=$(git rev-parse "$parent~0")
224         case "$parents" in
225         *" $parent "*)  ;;
226         *)      fail "child $child lacks parent $parent" ;;
227         esac
228 }
229
230 t-prep-newpackage () {
231         t-select-package $1
232         v=$2
233         t-archive-none $p
234         t-git-none
235         t-worktree $v
236         cd $p
237         if ! git show-ref --verify --quiet refs/heads/master; then
238                 git branch -m dgit/sid master
239                 git remote rm dgit
240         fi
241         cd ..
242 }
243
244 t-archive-none () {
245         t-select-package $1
246         t-archive-none-$t_archive_method
247 }
248 t-archive-none-aq () {
249         mkdir -p $tmp/aq/dsc_in_suite $tmp/mirror/pool/main
250
251         : >$tmp/aq/suites
252         local jsondelim="["
253
254         local suitespec
255         for suitespec in $suitespecs; do
256                 local suite=${suitespec%%:*}
257                 local sname=${suitespec#*:}
258
259                 >$tmp/aq/package.$suite.$p
260                 t-aq-archive-updated $suite $p
261
262                 >$tmp/aq/package.new.$p
263                 t-aq-archive-updated new $p
264
265                 ln -sf $suite $tmp/aq/dsc_in_suite/$sname
266
267                 cat <<END >>$tmp/aq/suites
268 $jsondelim
269    {
270       "archive" : "ftp-master",
271       "codename" : "$suite",
272       "components" : [
273          "main",
274          "contrib",
275          "non-free"
276       ],
277       "name" : "$sname",
278       "dakname" : "$sname"
279 END
280
281                 jsondelim="   },"
282
283         done
284         cat <<END >>$tmp/aq/suites
285     }
286 ]
287 END
288 }
289
290 t-aq-archive-updated () {
291         local suite=$1
292         local p=$2
293         local suitedir=$tmp/aq/dsc_in_suite/$suite
294         mkdir -p $suitedir
295         perl <$tmp/aq/package.$suite.$p >$suitedir/$p -wne '
296                 use JSON;
297                 use strict;
298                 our @v;
299                 m{^(\S+) (\w+) ([^ \t/]+)/(\S+)} or die;
300                 push @v, {
301                         "version" => "$1",
302                         "sha256sum" => "$2",
303                         "component" => "$3",
304                         "filename" => "$4",
305                 };
306                 END {
307                         my $json = JSON->new->canonical();
308                         print $json->encode(\@v) or die $!;
309                 }
310         '
311 }
312
313 t-archive-process-incoming () {
314         local suite=$1
315         mv $tmp/incoming/${p}_* $tmp/mirror/pool/main/
316         t-archive-query "$suite"
317 }
318
319 t-archive-query () {
320         local suite=${1-sid}
321         local dscf=main/${p}_${v}.dsc
322         t-archive-query-$t_archive_method "$suite" "$p" "$v" "$dscf"
323 }
324 t-archive-query-aq () {
325         local suite=$1
326         local p=$2
327         local v=$3
328         local dscf=$4
329         local sha; sha=`sha256sum <$tmp/mirror/pool/$dscf`
330         echo "${v} ${sha%  -} $dscf" >>$tmp/aq/package.$suite.${p}
331         t-aq-archive-updated $suite $p
332 }
333
334 t-archive () {
335         t-archive-none $1
336         v=$2
337         local dscf=${p}_$2.dsc
338         rm -f $tmp/mirror/pool/main/${p}_*
339         ln $troot/pkg-srcs/${p}_${2%-*}* $tmp/mirror/pool/main/
340         t-archive-query $suite
341         rm -rf $tmp/extract
342         mkdir $tmp/extract
343         (set -e; cd $tmp/extract; dpkg-source -x ../mirror/pool/main/$dscf)
344 }
345
346 t-git-dir-time-passes () {
347         touch -d 'last year' $dgitrepo
348 }
349
350 t-git-dir-check () {
351         local gitdir=$dgitrepo
352         case "$1" in
353         enoent)
354                 if test -e "$gitdir"; then fail "$gitdir exists"; fi
355                 return
356                 ;;
357         public) wantstat='7[75]5' ;;
358         secret) wantstat='7[70]0' ;;
359         *)      fail "$1 t-git-dir-check ?" ;;
360         esac
361         gotstat=`stat -c%a $gitdir`
362         case "$gotstat" in
363         *$wantstat) return ;;
364         *)      fail "$gitdir has mode $gotstat, expected $wantstat" ;;
365         esac
366 }
367
368 t-expect-fsck-fail () {
369         echo >>$tmp/fsck.expected-errors "$1"
370 }
371
372 t-git-fsck () {
373         local fsckerrs=$(git rev-parse --git-dir)/dgit-test-fsck.errs
374
375         set +e
376         LC_MESSAGES=C git fsck --no-dangling --strict 2>&1 \
377                 | tee $fsckerrs
378         ps="${PIPESTATUS[*]}"
379         set -e
380
381         local pats
382         if [ -f $tmp/fsck.expected-errors ]; then
383                 pats=(-w -f $tmp/fsck.expected-errors)
384         else
385                 test "$ps" = "0 0"
386         fi
387         pats+=(-e 'notice: HEAD points to an unborn branch')
388         pats+=(-e 'notice: No default references')
389
390         set +e
391         grep -v "${pats[@]}" $fsckerrs
392         rc=$?
393         set -e
394         case $rc in
395         1) ;; # no unexpected errors
396         0) fail "unexpected messages from git-fsck" ;;
397         *) fail "grep of git-fsck failed" ;;
398         esac
399 }
400
401 t-fscks () {
402         (
403         shopt -s nullglob
404         for d in $tmp/*/.git $tmp/git/*.git; do
405                 cd "${d%/.git}"
406                 t-git-fsck
407         done
408         )
409 }
410
411 t-ok () {
412         : '========================================'
413         t-fscks
414         t-save-artifacts
415         echo ok.
416 }
417
418 t-save-artifacts () {
419         artifacts="$AUTOPKGTEST_ARTIFACTS"
420         if [ x"$artifacts" = x ]; then return; fi
421         if [ x"tmp" = x ]; then return; fi
422         GZIP=-1v tar -C "$tmp" -zc -f "$artifacts/${0##*/}.tar.gz" \
423                 --exclude=\*.tar .
424 }
425
426 t-rm-dput-dropping () {
427         rm -f $tmp/${p}_${v}_*.upload
428 }
429
430 t-dgit () {
431         local dgit=${DGIT_TEST-dgit}
432         pwd >&2
433         : '
434 {{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{'
435         $dgit --dgit=$dgit --dget:-u --dput:--config=$tmp/dput.cf \
436  ${dgit_config_debian_alias-"--config-lookup-explode=dgit-distro.debian.alias-canon"} \
437  ${DGIT_GITDEBREBASE_TEST+--git-debrebase=}${DGIT_GITDEBREBASE_TEST} \
438                 ${distro+${distro:+-d}}${distro--dtest-dummy} \
439                 $DGIT_TEST_OPTS $DGIT_TEST_DEBUG \
440                 -kBCD22CD83243B79D3DFAC33EA3DBCBC039B13D8A $t_dgit_xopts "$@"
441         : '}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}
442 '
443 }
444
445 t-dgit-manpage () {
446         local section=$1
447         local page=$2
448         (export LC_ALL=C.UTF-8
449          if [ "$DGIT_TEST_INTREE" ]; then
450                 make -C $DGIT_TEST_INTREE $page.$section.view
451          else
452                 man $section $page
453          fi)
454 }
455
456 t-diff-nogit () {
457         diff --exclude=.git --exclude=.pc -ruN $*
458 }
459
460 t-files-notexist () {
461         local f
462         for f in "$@"; do
463                 if [ -e $f ]; then
464                         fail "$f exists!"
465                 fi
466         done
467 }
468
469 t-cloned-fetched-good () {
470         t-diff-nogit ../extract/$p-${v%-*} .
471         t-clean-on-branch dgit/sid
472         t-refs-same-start
473         t-refs-same \
474                 refs/heads/dgit/sid \
475                 refs/remotes/dgit/dgit/sid
476         t-refs-notexist refs/dgit/unstable refs/remotes/dgit/dgit/unstable
477 }
478
479 t-output () {
480         printf "%s${1:+\n}" "$1" >$tmp/t.want
481         shift
482         "$@" >$tmp/t.got
483         diff $tmp/t.want $tmp/t.got
484 }
485
486 t-clean-on-branch () {
487         t-output "## $1" git status -b --porcelain
488 }
489
490 t-setup-done () {
491         local savevars=$1
492         local savedirs=$2
493         local importeval=$3
494
495         local import=IMPORT.${DGIT_TEST_TESTNAME-${0##*/}}
496         exec 4>$tmp/$import.new
497
498         local vn
499         for vn in $savevars; do
500                 perl >&4 -"I$root" -MDebian::Dgit -e '
501                         printf "%s=%s\n", $ARGV[0], shellquote $ARGV[1]
502                 ' $vn "$(eval "printf '%s\n' \"\$$vn\"")"
503         done
504
505         (set -e; cd $tmp; tar cf $import.tar $savedirs)
506
507         printf >&4 "\n%s\n" "$importeval"
508
509         mv -f $tmp/$import.new $tmp/$import
510 }
511
512 t-setup-import () {
513         local setupname=$1
514
515         local setupsrc
516         local lock
517         if [ "x$tmpbase" = x ]; then
518                 # ADTTMP was set on entry to tests/lib, so we
519                 # are not sharing tmp area between tests
520                 setupsrc="$tmp"
521                 lock="$tmp/.dummy.lock"
522         else
523                 setupsrc="$tmpbase/$setupname"
524                 lock="$setupsrc.lock"
525         fi
526
527         local simport="$setupsrc/IMPORT.$setupname"
528
529         if ! [ -e "$simport" ]; then
530                 with-lock-ex -w "$lock" \
531                 xargs -0 -a $tmp/.save-env \
532                 bash -xec '
533                         cd "$1"; shift
534                         setupname="$1"; shift
535                         simport="$1"; shift
536                         if [ -e "$simport" ]; then exit 0; fi
537                         env - "$@" \
538                         "tests/setup/$setupname"
539                 ' x "$root" "$setupname" "$simport"
540         fi
541
542         if [ "x$setupsrc" != "x$tmp" ]; then
543                 (set -e; cd $tmp; tar xf "$simport.tar")
544         fi
545
546         . "$simport"
547 }
548
549 t-git-get-ref-exact () {
550         local ref=$1
551         # does not dereference, unlike t-git-get-ref
552         case "$ref" in
553         refs/*) ;;
554         *) fail "t-git-get-ref-exact bad $ref" ;;
555         esac
556         git for-each-ref --format='%(objectname)' "[r]efs/${ref#refs/}"
557 }
558
559 t-git-get-ref () {
560         local ref=$1
561         case "$ref" in
562         refs/*) ;;
563         *) fail "t-git-get-ref bad $ref" ;;
564         esac
565         (git show-ref -d $1 || test $? = 1) | perl -ne '
566                 $x = $1 if m#^(\w+) \Q'$1'\E(?:\^\{\})?$#;
567                 END { print "$x\n" if length $x; }
568         '
569 }
570
571 t-ref-same-exact () {
572         local name="$1"
573         local val; val=`t-git-get-ref-exact $name`
574         t-ref-same-val "$name" $val
575 }
576
577 t-ref-same () {
578         local name="$1"
579         local val; val=`t-git-get-ref $name`
580         t-ref-same-val "$name" $val
581 }
582
583 t-ref-head () {
584         local val; val=`git rev-parse HEAD`
585         t-ref-same-val HEAD $val
586 }
587
588 t-ref-same-val () {
589         local name="$1"
590         local val=$2
591         case "${t_ref_val-unset}" in
592         unset)          ;;
593         "$val")         ;;
594         *)              fail "ref varies: ($name)\
595  ${val:-nothing} != ${t_ref_val:-nothing} (${t_ref_names[*]})" ;;
596         esac
597         t_ref_val="$val"
598         t_ref_names+=("$name")
599 }
600
601 t-refs-same-start () {
602         unset t_ref_val
603         t_ref_names=()
604 }
605
606 t-refs-same () {
607         local g
608         for g in $*; do
609                 t-ref-same $g
610         done
611 }
612
613 t-refs-notexist () {
614         local val
615         for g in $*; do
616                 val=`t-git-get-ref $g`
617                 if [ "x$val" != x ]; then
618                         fail "ref $g unexpectedly exists ($val)"
619                 fi
620         done
621 }
622
623 t-v-tag () {
624         echo refs/tags/$tagpfx/${v//\~/_}
625 }
626
627 t-format-ref () {
628         git log -n1 --pretty=format:"$1" "$2"
629 }
630
631 t-sametree-parent () {
632         local ref=$1
633         local parent
634         local ctree; ctree=$(t-format-ref '%T' "$ref")
635         while :; do
636                 local psame=''
637                 for parent in $(t-format-ref '%P' "$ref"); do
638                         local ptree; ptree=$(t-format-ref '%T' "$parent")
639                         if [ "x$ptree" = "x$ctree" ]; then
640                                 psame+=" $parent"
641                         fi
642                 done
643                 case "$psame" in ""|" * *") break ;; esac
644                 ref="${psame# }"
645         done
646         echo "$ref"
647 }
648
649 t-check-pushed-master () {
650         local master; master=`t-git-get-ref refs/heads/master`
651         if [ x$master = x$t_ref_val ]; then return; fi
652         if [ x$master = x ]; then fail "failed to push master"; fi
653         # didn't update master, it must be not FF
654         local mbase; mbase=`t-git-merge-base $master $t_ref_val`
655         if [ x$mbase = x$master ]; then fail "failed to ff master"; fi
656 }
657
658 t-push-was-source-only () {
659         local f
660         t-files-notexist $tmp/incoming/${p}_${v}_*.deb \
661                          $tmp/incoming/${p}_${v}_*.udeb
662         # we permit _source.buildinfo files; see test_changes_source_only()
663         for f in $tmp/incoming/${p}_${v}_*.buildinfo; do
664             if [ -e $f ]; then
665                 case "$f" in
666                     *_source.buildinfo) ;;
667                     *) fail "non-source-only file $f exists!" ;;
668                 esac
669             fi
670         done
671 }
672
673 t-pushed-good () {
674         local branch=$1
675         local suite=${2:-sid}
676         t-refs-same \
677                 refs/heads/$branch
678         t-pushed-good-core
679 }
680         
681 t-pushed-good-core () {
682         t-ref-dsc-dgit
683         t-refs-same \
684                 `t-v-tag` \
685                 refs/remotes/dgit/dgit/$suite
686         t-refs-notexist \
687                 refs/heads/dgit/unstable \
688                 refs/remotes/dgit/dgit/unstable
689         (set -e; cd $dgitrepo
690          t-refs-same \
691                 refs/dgit/$suite \
692                 `t-v-tag`
693          ${t_check_pushed_master:- : NOT-DRS-NO-CHECK-PUSHED-MASTER}
694          t-refs-notexist \
695                 refs/dgit/unstable
696         )
697         git verify-tag `t-v-tag`
698 }
699
700 t-splitbrain-pushed-good--unpack () {
701         cd $tmp
702         rm -rf t-unpack
703         mkdir t-unpack
704         cd t-unpack
705         ln -s $tmp/mirror/pool/main/*.orig*.tar* .
706         ln -s $tmp/incoming/*.orig*.tar* . ||:
707         ln -s $incoming_dsc .
708         ln -s ${incoming_dsc/.dsc/.debian.tar}* .
709         dpkg-source "$@" -x *.dsc
710         cd */.
711         git init
712         git fetch ../../$p "refs/tags/*:refs/tags/*"
713 }
714
715 t-splitbrain-pushed-good--checkprep () {
716         git add -Af .
717         git rm --cached -r --ignore-unmatch .pc
718 }
719
720 t-splitbrain-pushed-good--checkdiff () {
721         local tag=$1
722         t-splitbrain-pushed-good--checkprep
723         t-output "" git diff --stat --cached $tag
724 }
725
726 t-splitbrain-pushed-good-start () {
727         dep14tag=refs/tags/test-dummy/${v//\~/_}
728         dgittag=$(t-v-tag)
729         t-output "" git status --porcelain
730         t-ref-head
731         t-refs-same $dep14tag
732         (set -e; cd $dgitrepo; t-refs-same $dep14tag)
733         git merge-base --is-ancestor $dep14tag $dgittag
734
735         t-refs-same-start
736         t-ref-same refs/heads/split.p
737         case "$(t-git-get-ref refs/heads/split.b)" in
738         "$t_ref_val") ;;
739         "$(git rev-parse refs/heads/split.p^0)") ;;
740         "$(git rev-parse refs/heads/split.p^1)") ;;
741         *) fail 'bad b/p' ;;
742         esac
743         t-pushed-good-core
744
745         t-incoming-dsc
746
747         t-splitbrain-pushed-good--unpack
748         t-splitbrain-pushed-good--checkdiff $dgittag
749 }
750 t-splitbrain-pushed-good-end-made-dep14 () {
751         t-splitbrain-pushed-good--checkdiff $dep14tag
752         cd $tmp/$p
753 }
754
755 t-splitbrain-rm-gitignore-patch () {
756         perl -i -pe '
757                 next unless $_ eq "auto-gitignore\n";
758                 die if $counter++;
759                 chomp;
760                 rename "debian/patches/$_", "../t-auto-gitignore" or die $!;
761                 $_ = "";
762         ' debian/patches/series
763 }
764
765 t-gbp-pushed-good () {
766         local suite=${1:-sid}
767         t-splitbrain-pushed-good-start
768
769         # Right, now we want to check that the maintainer tree and
770         # the dgit tree differ in exactly the ways we expect.  We
771         # achieve this by trying to reconstruct the maintainer tree
772         # from the dgit tree.
773
774         # So, unpack it withut the patches applied
775         t-splitbrain-pushed-good--unpack --skip-patches
776
777         # dgit might have added a .gitignore patch, which we need to
778         # drop and remove
779         t-splitbrain-rm-gitignore-patch
780
781         # Now the result should differ only in non-debian/ .gitignores
782         t-splitbrain-pushed-good--checkprep
783         git diff --cached --name-only $dep14tag >../changed
784         perl -ne '
785                 next if !m#^debian/# && m#(^|/)\.gitignore#;
786                 die "$_ mismatch";
787         ' <../changed
788
789         # If we actually apply the gitignore patch by hand, it
790         # should be perfect:
791         if [ -f ../t-auto-gitignore ]; then
792                 patch --backup-if-mismatch -p1 -u <../t-auto-gitignore
793         fi
794
795         t-splitbrain-pushed-good-end-made-dep14
796 }
797
798 t-unapplied-pushed-good () {
799         t-splitbrain-pushed-good-start
800         t-splitbrain-pushed-good--unpack --skip-patches
801         t-splitbrain-pushed-good-end-made-dep14
802 }
803
804 t-dpm-pushed-good () {
805         t-splitbrain-pushed-good-start
806         t-splitbrain-pushed-good--unpack
807         t-splitbrain-rm-gitignore-patch
808         t-splitbrain-pushed-good-end-made-dep14
809 }
810
811 t-commit-build-push-expect-log () {
812         local msg=$1
813         local mpat=$2
814         t-commit "$msg"
815         t-dgit build
816         LC_MESSAGES=C \
817         t-dgit push --new 2>&1 |tee $tmp/push.log
818         t-grep-mpat "$mpat" $tmp/push.log
819 }
820
821 t-822-field () {
822         local file=$1
823         local field=$2
824         perl -e '
825                 use Dpkg::Control::Hash;
826                 my $h = new Dpkg::Control::Hash allow_pgp=>1;
827                 $h->parse(\*STDIN,"'"$file"'");
828                 my $val = $h->{"'$field'"},"\n";
829                 die "'"$file $field"'" unless defined $val;
830                 print $val,"\n";
831         ' <$file
832 }
833
834 t-defdistro () {
835         export DGIT_TEST_DISTRO=''
836         distro=''
837         t-git-config dgit-suite.unstable.distro test-dummy
838 }
839
840 t-stunt-envvar () {
841         local var=$1
842         local tstunt=$2
843         eval '
844                 case "$'$var'" in
845                 "$tstunt:"*)    ;;
846                 *":$tstunt:"*)  ;;
847                 "")             '$var'="$tstunt" ;;
848                 *)              '$var'="$tstunt:$'$var'" ;;
849                 esac
850                 export '$var'
851         '
852 }
853
854 t-tstunt--save-real () {
855         local f="$1"
856         case "$f" in
857         */*) return ;;
858         esac
859
860         local rc
861         local real
862         set +e
863         real=$(
864                 p=":$PATH:"
865                 p="${p/:"$tmp/tstunt":/:}"
866                 p="${p%:}"
867                 p="${p#:}"
868                 PATH="$p"
869                 type -p "$f"
870         )
871         rc=$?
872         set -e
873
874         case $rc in
875         1)      return ;;
876         0)      ;;
877         *)      fail "did not find $f on PATH $PATH" ;;
878         esac
879
880         local varname=${f//[^_0-9a-zA-Z]/_}
881         varname=DGIT_TEST_REAL_${varname^^}
882
883         eval "
884                 : \${$varname:=\$real}
885                 export $varname
886         "
887 }
888
889 t-tstunt () {
890         local tstunt=$tmp/tstunt
891         t-stunt-envvar PATH $tstunt
892         t-stunt-envvar PERLLIB $tstunt
893         local f
894         for f in "$@"; do
895                 t-tstunt--save-real $f
896                 f="./$f"
897                 local d="$tstunt/${f%/*}"
898                 mkdir -p $d
899                 ln -sf "$troot/tstunt/$f" "$d"/.
900         done
901 }
902
903 t-tstunt-parsechangelog () {
904         t-tstunt dpkg-parsechangelog Dpkg/Changelog/Parse.pm
905 }
906
907 t-tstunt-lintian () {
908         t-tstunt lintian
909 }
910
911 t-tstunt-debuild () {
912         t-tstunt debuild
913 }
914
915 t-incoming-dsc () {
916         local dsc=${p}_${v}.dsc
917         incoming_dsc=$tmp/incoming/$dsc
918 }
919
920 t-ref-dsc-dgit () {
921         t-incoming-dsc
922         local val; val=`t-822-field $incoming_dsc Dgit`
923         val=$( perl -e '
924                 $_=shift @ARGV;
925                 die "Dgit $_ ?" unless m/^\w+\b/;
926                 print $&,"\n" or die $!;
927         ' "$val")
928         t-ref-same-val $incoming_dsc "$val"
929 }
930
931 t-apply-diff () {
932         local v1=$1
933         local v2=$2
934         (cd $troot/pkg-srcs;
935          debdiff ${p}_${v1}.dsc ${p}_${v2}.dsc || test $? = 1) \
936          | patch -p1 -u
937 }
938
939 t-gbp-unapplied-pq2qc () {
940         # does `gbp pq export'
941         # commits the resulting debian/patches on  qc/BRANCH
942         # leaves us on qc/BRANCH (eg "qc/quilt-tip"))
943         # qc/BRANCH is not fast-forwarding
944
945         gbp pq export
946
947         branch=`git symbolic-ref HEAD`
948         branch=${branch#refs/heads/}
949
950         case "$branch" in
951         */*) fail "unexpected branch $branch" ;;
952         esac
953
954         git branch -f qc/$branch
955         git checkout qc/$branch
956         git add debian/patches
957         git commit -m 'Commit patch queue'
958 }
959
960 t-git-pseudo-merge () {
961         # like   git merge -s ours
962         if [ ! "$git_pseuomerge_opts" ]; then
963                 if git merge --help \
964                  | grep -q allow-unrelated-histories; then
965                         git_pseuomerge_opts='--allow-unrelated-histories'
966                 fi
967                 git_pseuomerge_opts+=' -s ours'
968         fi
969         git merge $git_pseuomerge_opts "$@"
970 }
971
972 t-gbp-example-prep-no-ff () {
973         t-tstunt-parsechangelog
974         t-archive example 1.0-1
975         t-git-none
976         t-worktree 1.0
977
978         cd example
979
980         t-dgit fetch
981
982         git checkout -b patch-queue/quilt-tip-2 patch-queue/quilt-tip
983         gbp pq rebase
984
985         echo '/* some comment */' >>src.c
986         git add src.c
987         git commit -m 'Add a comment to an upstream file'
988
989         t-gbp-unapplied-pq2qc
990
991         t-commit 'some updates' 1.0-2
992 }
993
994 t-gbp-example-prep () {
995         t-gbp-example-prep-no-ff
996
997         t-git-pseudo-merge \
998                 -m 'Pseudo-merge to make descendant of archive' \
999                 remotes/dgit/dgit/sid
1000 }
1001
1002 t-make-badcommit () {
1003         badcommit=$(
1004                 git cat-file commit HEAD | \
1005                 perl -pe 's/^committer /commiter /' | \
1006                 git hash-object -w -t commit --stdin
1007         )
1008         t-expect-fsck-fail $badcommit
1009 }
1010
1011 t-commit () {
1012         local msg=$1
1013         v=${2:-${majorv:-1}.$revision}
1014         dch --force-distribution -v$v --distribution ${3:-unstable} "$1"
1015         git add debian/changelog
1016         debcommit
1017         revision=$(( ${revision-0} + 1 ))
1018 }
1019
1020 t-dch-r-rune () {
1021         local cmd="$1"; shift
1022         local suite=${1-unstable}
1023         $cmd -r -D "$suite" ''
1024 }
1025
1026 t-dch-commit-r () {
1027         t-dch-r-rune t-dch-commit "$@"
1028 }
1029
1030 t-dch-commit () {
1031         faketime @"${GIT_AUTHOR_DATE% *}" dch "$@"
1032         git commit -m "dch $*" debian/changelog
1033 }
1034
1035 t-git-config () {
1036         git config --global "$@"
1037 }
1038
1039 t-drs () {
1040  t-git-config dgit-distro.test-dummy.git-url "ext::$troot/drs-git-ext %S "
1041  t-git-config dgit-distro.test-dummy.git-check true
1042  t-git-config dgit-distro.test-dummy.git-create true
1043  t-git-config dgit-distro.test-dummy.dgit-tag-format new,old,maint
1044         cp $troot/gnupg/{dd.gpg,dm.gpg,dm.txt} $tmp/.
1045         cp $troot/suites $tmp/.
1046         cp $troot/suites $tmp/suites-master
1047
1048         export t_check_pushed_master=t-check-pushed-master
1049
1050         drs_dispatch=$tmp/distro=test-dummy
1051         mkdir $drs_dispatch
1052
1053         if [ "x$DGIT_TEST_INTREE" != x ]; then
1054                 ln -sf "$DGIT_TEST_INTREE" $drs_dispatch/dgit-live
1055         fi
1056
1057         ln -sf $tmp/git $drs_dispatch/repos
1058         ln -sf $tmp/suites $tmp/suites-master $tmp/dm.txt $drs_dispatch/
1059         mkdir -p $drs_dispatch/keyrings
1060         ln -sf $tmp/dd.gpg $drs_dispatch/keyrings/debian-keyring.gpg
1061         ln -sf $tmp/dm.gpg $drs_dispatch/keyrings/debian-maintainers.gpg
1062         ln -sf /bin/true $drs_dispatch/policy-hook
1063 }
1064
1065 t-newtag () {
1066  export tagpfx=archive/test-dummy
1067  t-git-config dgit-distro.test-dummy.dgit-tag-format new,maint
1068 }
1069 t-oldtag () {
1070  export tagpfx=test-dummy
1071  t-git-config dgit-distro.test-dummy.dgit-tag-format old
1072 }
1073
1074 t-dsd () {
1075         t-drs
1076  t-git-config dgit-distro.test-dummy.ssh "$troot/dsd-ssh"
1077  t-git-config dgit-distro.test-dummy.git-check ssh-cmd
1078  t-git-config dgit-distro.test-dummy.git-create true
1079  t-git-config dgit-distro.test-dummy.git-url \
1080                 "ext::$troot/dsd-ssh X %S /dgit/test-dummy/repos"
1081
1082  t-git-config dgit-distro.test-dummy.diverts.drs /drs
1083  t-git-config dgit-distro.test-dummy/drs.ssh "$troot/ssh"
1084  t-git-config dgit-distro.test-dummy/drs.git-url $tmp/git
1085  t-git-config dgit-distro.test-dummy/drs.git-check ssh-cmd
1086  t-git-config dgit-distro.test-dummy/drs.git-create ssh-cmd
1087
1088         echo 'no-such-package* drs' >$drs_dispatch/diverts
1089 }
1090
1091 t-policy-admin () {
1092         : '(((((((((((((((((((((((((((((((((((((((('
1093         ${DGIT_INFRA_PFX}dgit-repos-admin-debian --repos $tmp/git "$@"
1094         : '))))))))))))))))))))))))))))))))))))))))'
1095 }
1096
1097 t-policy-nonexist () {
1098         ln -sf no-such-file-or-directory $drs_dispatch/policy-hook
1099 }
1100
1101 t-make-hook-link () {
1102         local hook=$1 # in infra/
1103         local linkpath=$2
1104         hook=${DGIT_INFRA_PFX}$hook
1105         case $hook in
1106         */*)    ;;
1107         *)      hook=`type -P $hook` ;;
1108         esac
1109         ln -sf "$hook" $linkpath
1110 }
1111
1112 t-policy () {
1113         local policyhook=$1
1114         t-make-hook-link $policyhook $drs_dispatch/policy-hook
1115 }
1116
1117 t-debpolicy () {
1118         t-dsd
1119         t-policy dgit-repos-policy-debian
1120
1121         mkdir $tmp/git
1122         t-policy-admin create-db
1123 }
1124
1125 t-policy-periodic () {
1126         : '(((((((((((((((((((((((((((((((((((((((('
1127         ${DGIT_REPOS_SERVER_TEST-dgit-repos-server} \
1128                 test-dummy $drs_dispatch '' --cron
1129         : '))))))))))))))))))))))))))))))))))))))))'
1130 }
1131
1132 t-restrict () {
1133         local restriction=$1
1134         (cd $root; t-restriction-$restriction >&2)
1135 }
1136
1137 t-dependencies () {
1138         : "Hopefully installed: $*"
1139 }
1140
1141 t-chain-test () {
1142         local ct=$1
1143         local d=${0%/*}
1144         cd $root
1145         export DGIT_TEST_TESTNAME="$testname"
1146         export DGIT_TEST_TMPBASE="$tmpbase"
1147         export ADTTMP=$tmp
1148         exec "$d/$ct"
1149 }       
1150
1151 t-alt-test () {
1152         local t=${0##*/}
1153         t-${t%%-*}
1154         t-chain-test "${t#*-}"
1155 }
1156
1157 t-git-config dgit.default.old-dsc-distro test-dummy
1158
1159 for import in ${autoimport-gnupg}; do
1160         case "$0" in
1161         */$import) ;;
1162         *)
1163                 t-setup-import $import
1164                 ;;
1165         esac
1166 done